import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/**
 * ǥɽΤδ쥯饹
 *
 * Applet ĥơΤ褦ʵǽ󶡤롣
 * <ul>
 * <li>GraphPanel ѤΥܥ
 * <li>դΥǡ HTML ɤ߹ readParam()
 * <li>դλɽΰ٤ drawEdge()
 * <li>ɽ®ĴΤ sleep()
 * </ul>
 * 
 * @author Nobuyuki Tsuchimura
 * @see GraphPanel
 */
abstract public class GraphApplet extends Applet implements Runnable {
    /** դĺɸ */
    protected int x[], y[];
    /** ĺ֤εΥ */
    protected int d[][];

    /** ʸ */
    final static Color FG_COLOR = Color.white;
    /** طʿ */
    final static Color BG_COLOR = Color.black;
    /** ܥο */
    final static Color BUTTON_COLOR = Color.green.darker();

    protected volatile Thread thread = null;
    protected boolean threadSuspended = false;
    protected boolean oneStep = false;
    protected boolean oneInit = false;
    private GraphPanel graphPanel;
    protected Panel northPanel, ctrlPanel, messagePanel;
    protected Button playButton, stepButton, initButton;

    /**
       ޤ(르ꥺȤϴطʤ)褹ǽ񤯡
       <tt>drawEdge(i,j,g)</tt> ƤӽФȤǼ¸롣
       @see #drawEdge(int,int,Graphics)
    */
    abstract public void drawAllEdges( Graphics g );

    /**
       ޤ褹롣drawAllEdges ͳǤΤ߻ȤäƤ褤
       @param i ޤλĺֹ
       @param j ޤνĺֹ
       @param g <tt>drawAllEdges()</tt> Ϳ줿 <tt>Graphics</tt>
       @see #drawAllEdges
       @see #drawEdge(int,int)
    */
    public void drawEdge( int i, int j, Graphics g ) {
        graphPanel.drawEdge( i, j, g );
    }

    /**
       르ꥺɲ/ޤ褹롣
       @param i ޤλĺֹ
       @param j ޤνĺֹ
       @see #drawEdge(int,int,Graphics)
    */
    public void drawEdge( int i, int j ) {
        graphPanel.drawEdge( i, j );
    }

    public void setColors( Color node, Color edge, Color edgeBg ) {
        graphPanel.setColors( node, edge, edgeBg );
    }

    /** TSPlib Υǡ x[], y[], d[][] ɤ߹ */
    public void readParam() {
	boolean att = getParameter("weight").equalsIgnoreCase("att");
	int n = Integer.parseInt( getParameter("n") );
        setSleep( 2000 / (int)Math.pow(n, 0.7) );

	x = new int[n];
        y = new int[n];
	d = new int[n][n];

	for ( int i=0; i<n; i++ ) {
	    StringTokenizer t = new StringTokenizer(getParameter("c"+(i+1)));
	    x[i] = (int)Math.round(Double.parseDouble(t.nextToken()));
	    y[i] = (int)Math.round(Double.parseDouble(t.nextToken()));
	    for ( int j=0; j<i; j++ ) {
		final int dx = x[i] - x[j];
		final int dy = y[i] - y[j];
		d[i][j] = d[j][i] = att ?
		    (int)Math.ceil( Math.sqrt((dx*dx+dy*dy)/10.0) ) : // att
		    (int)Math.round( Math.sqrt(dx*dx+dy*dy) );        // Euclid2
	    }
	}
    }

    /** 󥹥ȥ饯 */
    public void init() {
        System.out.println("GraphApplet 1.2");
	removeAll();
        graphPanel = new GraphPanel(this);
        northPanel = new Panel();
        ctrlPanel  = new Panel();
        messagePanel = new Panel();

	setLayout( new BorderLayout() );
        add( graphPanel, BorderLayout.CENTER );
        add( northPanel, BorderLayout.NORTH );

        northPanel.setLayout( new FlowLayout() );
        northPanel.add( ctrlPanel );
        northPanel.add( messagePanel );

	setBackground( BG_COLOR );
	setForeground( FG_COLOR );
        Font font;
        do { sleep(100);  font = getFont(); } while ( font == null );
	setFont( new Font( font.getName(), Font.PLAIN, font.getSize()+2 ) );

	// Play, Step, Init γƥܥ֤
        playButton = addCtrlButton( "",     new PlayButtonListener() );
        stepButton = addCtrlButton( "Step", new StepButtonListener() );
        initButton = addCtrlButton( "Init", new InitButtonListener() );
        setSuspended( false );
    }

    /** ѥܥ֤롣 */
    private Button addCtrlButton( String title, ActionListener listener ) {
        Button b = new Button( title );
        b.setBackground( BUTTON_COLOR );
        b.setForeground( FG_COLOR );
        b.addActionListener( listener );
        ctrlPanel.add( b );
        return b;
    }

    /** start() ͳǸƤӽФ */
    public void run() {
        readParam();
        graphPanel.setNodes( x, y );
        validate();
        repaint();
        while ( !isShowing() ) sleep( 300 );
    }

    public void start() {
	thread = new Thread( this );
	thread.start();
    }

    public void stop() {
	thread = null;
    }

    /** Ԥ */
    private int wait = 0;
    /** Ԥ֤ͰʾˤʤСºݤ wait  */
    private static final int WAIT_MIN = 100;
    /** άԤ */
    private int waitDefault = 100;

    /**
       <tt>sleep()</tt> ǤԤ֤ꤹ롣
       @see #sleep()
    */
    public void setSleep( int msec ) {
        waitDefault = msec;
    }

    /**
       Ԥ򤹤롣
       Ԥ֤ <tt>setSleep()</tt> ꤷƤ
       @return false ʤ, true ʤ
       @see #sleep(int)
       @see #setSleep
     */
    public boolean sleep() {  return sleep( waitDefault );  }

    /**
       Ԥ򤹤롣
       ºݤߤΤϡԤ֤Ѥ
       <tt>WAIT_MIN</tt> ߥðʾˤʤä
       ޤꤷԤ֤ˤ餺
       ܥ <tt>setSuspended(true)</tt> ˤꡢ
       Ĺߤ뤳Ȥ⤢롣
       @param msec Ԥ֡ʥߥá
       @return false ʤ, true ʤ       
       @see #sleep
       @see #setSuspended
    */
    public boolean sleep( int msec ) {
	//System.out.println("sleep("+msec+")");
        wait += msec;
        if ( wait < WAIT_MIN ) {
            if ( !oneStep ) return true;
            wait = WAIT_MIN;
        }
        oneStep = false;
        if ( oneInit ) {
            oneInit = false;
            threadSuspended = false;
            return false;
        }
        do {
            //System.out.println("wait " + wait + oneStep);
            Thread t = Thread.currentThread();
            if (thread != t) return false;
            try {
                Thread.sleep( wait );
            } catch ( InterruptedException e ) {
                return false;
            }
        } while ( threadSuspended && !oneStep && !oneInit );
        wait = 0;
        return true;
    }
    //  http://java.sun.com/j2se/1.4/ja/docs/ja/guide/misc/threadPrimitiveDeprecation.html


    /**
       ޥĺ򤹤롣
       @return ĺֹ
    */
    public int getStartingIndex() {
	graphPanel.setMouseHandle( true );
	setSuspended( true );
	sleep( 300 );
	graphPanel.capturing = false;
        return graphPanel.index;
    }

    /** Init ܥ󤬲ޤԤġ*/
    public void sleepForever() {
        playButton.setEnabled( false );
        stepButton.setEnabled( false );
        threadSuspended = false;
        while ( sleep(300) );
    }

    /** åޤԤġ
    public void waitForClick() {
        graphPanel.clicked = false;
        while ( !graphPanel.clicked ) sleep( 300 );
    }
    */

    /**
       <tt>sleep()</tt> θƤӽФߤ뤫ɤꤹ롣
       @param enable true ʤ(ܥޤ)ߡ
       false ʤ sleep ư롣
       @see #sleep(int)
    */
    public void setSuspended( boolean enable ) {
        playButton.setLabel( enable ? " Play " : " Pause" );
        playButton.setEnabled( true );
        stepButton.setEnabled( enable );
        threadSuspended = enable;
    }

    private class PlayButtonListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            setSuspended( !threadSuspended );
        }
    }
    private class StepButtonListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            oneStep = true;
        }
    }
    private class InitButtonListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            oneInit = true;
        }
    }
}
